Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## net.sf.saxon.sort
Class AtomicComparer

    java.lang.Object
      net.sf.saxon.sort.AtomicComparer

All Implemented Interfaces:
  java.util.Comparator, java.io.Serializable

public class AtomicComparer
extends java.lang.Object
implements java.util.Comparator, java.io.Serializable

A Comparator used for comparing atomic values of arbitrary item types. It encapsulates a Collator that is used when the values to be compared are strings. It also supports a separate method for testing equality of items, which can be used for data types that are not ordered.

See Also:
  Serialized Form

Constructor Summary
`AtomicComparer(java.util.Comparator collator, Configuration config)`
`AtomicComparer(java.util.Comparator collator, XPathContext conversion)` Create an AtomicComparer

Method Summary
`int` | `compare(java.lang.Object a, java.lang.Object b)` Compare two AtomicValue objects according to the rules for their data type.
`boolean` | `comparesEqual(java.lang.Object a, java.lang.Object b)` Compare two AtomicValue objects for equality according to the rules for their data type.
`java.lang.Object` | `getComparisonKey(java.lang.Object a)` Get a comparison key for an object.

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Methods inherited from interface java.util.Comparator
`equals`

Constructor Detail

### AtomicComparer

    public AtomicComparer(java.util.Comparator collator,
                          XPathContext conversion)

  Create an AtomicComparer

Parameters:
  `collator` - the collation to be used
  `conversion` - a context, used when converting untyped atomic values to the target type.

### AtomicComparer

    public AtomicComparer(java.util.Comparator collator,
                          Configuration config)

Method Detail

### compare

    public int compare(java.lang.Object a,
                       java.lang.Object b)

  Compare two AtomicValue objects according to the rules for their data type. UntypedAtomic values are compared as if they were strings; if different semantics are wanted, the conversion must be done by the caller.

  Specified by:
    `compare` in interface `java.util.Comparator`
  Parameters:
    `a` - the first object to be compared. It is intended that this should be an instance of AtomicValue, though this restriction is not enforced. If it is a StringValue, the collator is used to compare the values, otherwise the value must implement the java.util.Comparable interface.
    `b` - the second object to be compared. This must be comparable with the first object: for example, if one is a string, they must both be strings.
  Returns:
    <0 if a0 if a>b
  Throws:
    `java.lang.ClassCastException` - if the objects are not comparable

### comparesEqual

    public boolean comparesEqual(java.lang.Object a,
                                 java.lang.Object b)

  Compare two AtomicValue objects for equality according to the rules for their data type. UntypedAtomic values are compared by converting to the type of the other operand.

  Parameters:
    `a` - the first object to be compared. It is intended that this should be an instance of AtomicValue, though this restriction is not enforced. If it is a StringValue, the collator is used to compare the values, otherwise the value must implement the equals() method.
    `b` - the second object to be compared. This must be comparable with the first object: for example, if one is a string, they must both be strings.
  Returns:
    <0 if a0 if a>b
  Throws:
    `java.lang.ClassCastException` - if the objects are not comparable

### getComparisonKey

    public java.lang.Object getComparisonKey(java.lang.Object a)

  Get a comparison key for an object. This must satisfy the rule that if two objects are equal, then their comparison keys are equal, and vice versa. There is no requirement that the comparison keys should reflect the ordering of the underlying objects.

Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD